#include <htc.h>
#include <math.h>

#include "lcd.h"

#pragma config WDT = OFF
#pragma LVP = OFF
#pragma OSC = INTIO67

//Simple Delay Routine
void Wait(unsigned int delay)
{
for(;delay;delay--)
__delay_us(100);
}
void ADCInit(void){
	ADCON0=0b00000001;	// select Fosc/2
	ADCON1=0b00001110;	// select left justify result. A/D port configuration 0
	ADCON2=0b00001010;
}
unsigned char read_adc(unsigned char ){
	ADON = 1;	// initiate conversion on the selected channel
	while(ADON = 1)continue;
	return(ADRESH);	// return 8 MSB of the result
}
void main()
{
//Let the LCD Module start up
Wait(100);

//Initialize the LCD Module
LCDInit(LS_BLINK);

//Initialize the ADC Module
ADCInit();

//Clear the Module
LCDClear();

//Write a string at current cursor pos
LCDWriteString("Temperature:");
LCDWriteStringXY(4,1,"Degree C");

/*	while(1)
{
unsigned int val;	//read_adc
unsigned int t;	 //Temperature


val=read_adc();	//Read Channel 0

//t=round(val*0.48876);//Convert to Degree Celcius
t=round(val*100);

LCDWriteIntXY(0,1,t,3);//Prit IT!


Wait(1000);
}
*/

while(1)
{
unsigned int val;
unsigned int t;	 //Temperature

val=read_adc(); //Read Channel 0
//voltage= ((val)/1100)*5;
//The above formula give voltage in Volts, to get Voltage in mili Volts (mV) we must multiply it with 1000, so

//voltage=((val)/1100)*5*1000); //Voltage is in mV
//since (1/220)mV = 1 degree, to get temperature we must divide it by 1/220, so

//t=((val)/1100)*5*1000*220); //t is in degree centigrade
//simplifying further we get

//t=((val/1100)*1100000);
//t=(val*1000);
//we round off this value, so

t=round(val*1075.2688172043);

LCDWriteIntXY(0,1,t,3);//Prit IT!


Wait(1000);

}	
}